workspace = {}
gravity = 3
function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
    return x1 < x2+w2 and
           x2 < x1+w1 and
           y1 < y2+h2 and
           y2 < y1+h1
  end

function AddForce(amountx,amounty,object)
    object.velx = object.velx + amountx--(object.xpos - object.olxpos) + amountx * love.timer.getAverageDelta()
    object.vely = object.vely + amounty--(object.ypos - object.olypos) + amounty * love.timer.getAverageDelta()
end

function collide(object)
    for i,v in ipairs(workspace) do
        if CheckCollision(object.xpos,object.ypos,object.x,object.y,v.xpos,v.ypos,v.x,v.y) and v ~= object then
            if object.olypos < v.ypos then
                if object.xpos > v.xpos and (object.xpos + object.x) < (v.xpos + v.x) then
                    object.vely = 0
                    object.ypos = object.olypos
                    object.ypos = (v.ypos - object.y)
                end
                
            end
            if object.olypos + object.y > v.ypos  then
                if object.xpos > v.xpos and (object.xpos + object.x) < (v.xpos + v.x) then
                    object.vely = 0
                object.ypos = object.olypos
                object.ypos = ((v.ypos + v.y))
                end
            end


            



            if object.olxpos < v.xpos then
                if object.ypos > v.ypos and (object.ypos + object.y) < (v.ypos + v.y) then
                    object.velx = 0
                    object.xpos = object.olxpos
                    object.xpos = (v.xpos - object.x)
                end
            end

            if object.olxpos + object.x > v.xpos then
                if object.ypos > v.ypos and (object.ypos + object.y) < (v.ypos + v.y) then
                    object.velx = 0
                object.xpos = object.olxpos
                object.xpos = ((v.xpos + v.x))
                end
            end
        end
    end
end

function CreateBox(x,y,xpos,ypos,name,anchored,col)
    box = {
        type = "box",
        x = x,
        y = y,
        cancollide = col,
        xpos = xpos,
        ypos = ypos,
        olxpos = 0,
        olypos = 0,
        velx = 0,
        vely = 0,
        anchored = anchored,
        name = name
    }
    table.insert(workspace,box)
end

function CreateCircle(x,y,r,name,anchored)
    circle = {
        type = "circle",
        radius = r,
        xpos = xpos,
        ypos = ypos,
        olxpos = 0,
        olypos = 0,
        velx = 0,
        vely = 0,
        anchored = anchored,
        name = name
    }
    table.insert(workspace,circle)
end

function CheckName(namer)
    for i, v in ipairs(workspace) do
        if v.name == namer then
            return true
        end
    end
end

function GetObject(namer)
    for i, v in ipairs(workspace) do
        if v.name == namer then
            return v
        end
    end
end










for i,v in ipairs(workspace) do
    v.olxpos = v.xpos
    v.olypos = v.ypos
    if v.anchored == false then
        v.vely = v.vely + gravity
        v.ypos = v.ypos - v.vely
        v.xpos = v.xpos + v.velx
    end
end

function func_update()
    for i,v in ipairs(workspace) do
        v.olxpos = v.xpos
        v.olypos = v.ypos
        if v.anchored == false then
            v.vely = v.vely + gravity
            v.xpos = v.xpos + (v.velx * love.timer.getAverageDelta())
            v.ypos = v.ypos + (v.vely * love.timer.getAverageDelta())
        end
        collide(v)
    end
end